// BonSrcDecoder.h: CBonSrcDecoder NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "IMediaDecoder.h"
#include "IBonDriver.h"
#include "TsUtilClass.h"


// G[R[h
#define BSDEC_NOERROR			0x00000000UL	// G[Ȃ
#define BSDEC_TUNERERROR		0x00000001UL	// `[iG[
#define BSDEC_INTERNALERROR		0x00000002UL	// G[
#define BSDEC_TUNERNOTOPEN		0x00000003UL	// `[iɕĂ
#define BSDEC_ALREADYOPEN		0x00000004UL	// `[iɊJĂ
#define BSDEC_ALREADYPLAYING	0x00000005UL	// ɍĐĂ
#define BSDEC_NOTPLAYING		0x00000006UL	// ĐĂȂ


/////////////////////////////////////////////////////////////////////////////
// Bon\[XfR[_(`[iTSXg[M)
/////////////////////////////////////////////////////////////////////////////
// Output	#0	: CMediaData		TSXg[
/////////////////////////////////////////////////////////////////////////////

class CBonSrcDecoder : public IMediaDecoder  
{
public:
	CBonSrcDecoder();
	virtual ~CBonSrcDecoder();

// IMediaDecoder
	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CBonSrcDecoder
	const bool OpenTuner(void);
	const bool CloseTuner(void);

	const bool Play(void);
	const bool Stop(void);

	const bool SetChannel(const BYTE byChannel);
	const float GetSignalLevel(void);

	const DWORD GetLastError(void) const;

protected:
	const bool PurgeStream(void);
	virtual void OnTsStream(BYTE *pStreamData, DWORD dwStreamSize);

	CCriticalLock m_CriticalLock;
	bool m_bIsPlaying;
	DWORD m_dwLastError;

private:
	static DWORD WINAPI StreamRecvThread(LPVOID pParam);

	IBonDriver *m_pBonDriver;
	HANDLE m_hStreamRecvThread;
	bool m_bKillSignal;
};
