// TsDemuxer.cpp: CTsDemuxer NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsDemuxer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CTsDemuxer::CTsDemuxer()
	: IMediaDecoder()
{
	// R[obNZbg
	m_VideoPesParser.SetRecvCallback(CTsDemuxer::OnVideoPesPacket, (PVOID)this);
	m_AudioPesParser.SetRecvCallback(CTsDemuxer::OnAudioPesPacket, (PVOID)this);

	m_AdtsParser.SetRecvCallback(CTsDemuxer::OnAdtsFrame, (PVOID)this);
	m_Mpeg2Parser.SetRecvCallback(CTsDemuxer::OnMpeg2Sequence, (PVOID)this);

	// fobOp
	::ZeroMemory(&m_PidCountArray, sizeof(m_PidCountArray));
}

CTsDemuxer::~CTsDemuxer()
{

}

void CTsDemuxer::Reset()
{
	// fobOp
	for(WORD wIndex = 0U ; wIndex < 0x1FFFU ; wIndex++){
		if(m_PidCountArray[wIndex])TRACE(TEXT("[%04X] PidCount = %lu\n"), wIndex, m_PidCountArray[wIndex]);
		}
	::ZeroMemory(&m_PidCountArray, sizeof(m_PidCountArray));

	m_PatTable.Reset();
	m_PmtTable.Reset();

	m_VideoPesParser.Reset();
	m_AudioPesParser.Reset();

	m_AdtsParser.Reset();
	m_Mpeg2Parser.Reset();

	m_TsClockRef.Reset();
	
	m_PsiTableSingle.Reset();	

	// ʃfR[_Zbg
	IMediaDecoder::Reset();
}

const DWORD CTsDemuxer::GetInputNum() const
{
	return 1UL;
}

const DWORD CTsDemuxer::GetOutputNum() const
{
	return 1UL;	// b
}

const bool CTsDemuxer::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex >= GetInputNum())return false;

	CTsPacket *pTsPacket = static_cast<CTsPacket *>(pMediaData);

	// PIDɂpPbgtB^O
	RoutePacket(pTsPacket);

	// ̃tB^Ƀf[^n
	OutputMedia(pMediaData);

	return true;
}

const bool CTsDemuxer::RoutePacket(const CTsPacket *pPacket)
{
	m_PidCountArray[pPacket->GetPID()]++;

	// ŒPID̃pPbg
	switch(pPacket->GetPID()){
		case 0x0000U :	m_PatTable.StorePacket(pPacket);	return true;	// PAT (Program Association Table)
		case 0x0001U :	return false;	// CAT (Conditional Access Table)
		case 0x0011U :	return false;	// SDT (Service Description Table)
		case 0x0012U :	return false;	// EIT (Event Information Table)
		case 0x0013U :	return false;	// RST (Running Status Table)
		case 0x0014U :	return false;	// TOT (Time Offset Table)
		case 0x0022U :	return false;	// PCAT (Partical Content Announcement Table)
		case 0x0024U :	return false;	// BIT (Broadcaster Information Table)
		case 0x0025U :	return false;	// NBIT/LDT (Network Board Information Table/Linked Description Table)
		case 0x1FFFU :	return false;	// NULL Packet
		}

// ͎bAPMT𕡐vOɑΉāAOIł悤ɂKvB
/*
	// PCRpPbg
	if(m_TsClockRef.StorePacket(pPacket, m_PmtTable.GetPcrPID())){
		return true;
		}
*/
	// PID̃pPbg
	if(pPacket->GetPID() == m_PatTable.GetPmtPID(0UL)){
		m_PmtTable.StorePacket(pPacket);
		return true;
		}
/*
	// fPESpPbgo
	if(pPacket->GetPID() == m_PmtTable.GetEsPID(0UL)){
		m_VideoPesParser.StorePacket(pPacket);
		return true;
		}

	// PESpPbgo
	if(pPacket->GetPID() == m_PmtTable.GetEsPID(1UL)){
		m_AudioPesParser.StorePacket(pPacket);
		return true;
		}
*/

	return false;
}

void CALLBACK CTsDemuxer::OnVideoPesPacket(const CPesPacket *pPacket, const PVOID pParam)
{
	// fPESpPbg󂯎R[obN
	CTsDemuxer *pThis = static_cast<CTsDemuxer *>(pParam);
	
	// MPEG2p[TɃf[^n
	pThis->m_Mpeg2Parser.StorePacket(pPacket);
}

void CALLBACK CTsDemuxer::OnAudioPesPacket(const CPesPacket *pPacket, const PVOID pParam)
{
	// PESpPbg󂯎R[obN
	CTsDemuxer *pThis = static_cast<CTsDemuxer *>(pParam);

	// ADTSp[TɃf[^n
	pThis->m_AdtsParser.StorePacket(pPacket);
}

void CALLBACK CTsDemuxer::OnMpeg2Sequence(const CMpeg2Sequence *pSequence, const PVOID pParam)
{
	// MPEG2-ESV[PX󂯎R[obN
	CTsDemuxer *pThis = static_cast<CTsDemuxer *>(pParam);

	// ʃfR[_Ƀf[^n
	pThis->OutputMedia(new CMpeg2Sequence(*pSequence), 0);
}

void CALLBACK CTsDemuxer::OnAdtsFrame(const CAdtsFrame *pFrame, const PVOID pParam)
{
	// ADTSt[󂯎R[obN
	CTsDemuxer *pThis = static_cast<CTsDemuxer *>(pParam);
	
	// ʃfR[_Ƀf[^n
	pThis->OutputMedia(new CAdtsFrame(*pFrame), 1);
}
