// TsDescrambler.cpp: CTsDescrambler NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsDescrambler.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CTsDescrambler \z/
//////////////////////////////////////////////////////////////////////

CTsDescrambler::CTsDescrambler()
	: IMediaDecoder()
	, m_dwInputPacketCount(0UL)
	, m_dwOutputPacketCount(0UL)
{
	// PATe[uPID}bvǉ
	m_PidMapManager.MapTarget(0x0000U, new CPatTable, CTsDescrambler::OnPatUpdated, static_cast<PVOID>(this));
}

CTsDescrambler::~CTsDescrambler()
{
	CloseBcasCard();
}

void CTsDescrambler::Reset(void)
{
	// Ԃ
	m_PidMapManager.UnmapAllTarget();

	// PATe[uPID}bvǉ
	m_PidMapManager.MapTarget(0x0000U, new CPatTable, CTsDescrambler::OnPatUpdated, static_cast<PVOID>(this));

	// vf[^
	m_dwInputPacketCount = 0UL;
	m_dwOutputPacketCount = 0UL;

	// fR[_
	IMediaDecoder::Reset();
}

const DWORD CTsDescrambler::GetInputNum(void) const
{
	return 1UL;
}

const DWORD CTsDescrambler::GetOutputNum(void) const
{
	return 1UL;
}

const bool CTsDescrambler::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex >= GetInputNum())return false;

	CTsPacket *pTsPacket = static_cast<CTsPacket *>(pMediaData);

	// ̓pPbgJEg
	if(m_dwInputPacketCount < 0xFFFFFFFFUL)m_dwInputPacketCount++;

	// PID[eBO
	m_PidMapManager.StorePacket(pTsPacket);

	// pPbgo
	if(!pTsPacket->IsScrambled()){
		// o̓pPbgJEg
		if(m_dwOutputPacketCount < 0xFFFFFFFFUL)m_dwOutputPacketCount++;

		// pPbgfR[_Ƀf[^n
		OutputMedia(pMediaData);
		}
	else{
		// s\̏ꍇ̓pPbgj
		pMediaData->Delete();
		}

	return true;
}

const bool CTsDescrambler::OpenBcasCard(DWORD *pErrorCode)
{
	// J[h[_B-CASJ[hĊJ
	const bool bReturn = m_BcasCard.OpenCard();
	
	// G[R[hZbg
	if(pErrorCode)*pErrorCode = m_BcasCard.GetLastError();

	return bReturn;
}

void CTsDescrambler::CloseBcasCard(void)
{
	// B-CASJ[h
	m_BcasCard.CloseCard();
}

const bool CTsDescrambler::GetBcasCardID(BYTE *pCardID)
{
	// J[hID擾
	const BYTE *pBuff = m_BcasCard.GetBcasCardID();
	
	// obt@ɃRs[
	if(pCardID && pBuff)::CopyMemory(pCardID, pBuff, 6UL);
	
	return (pBuff)? true : false;
}

const DWORD CTsDescrambler::GetInputPacketCount(void) const
{
	// ̓pPbgԂ
	return m_dwInputPacketCount;
}

const DWORD CTsDescrambler::GetOutputPacketCount(void) const
{
	// o̓pPbgԂ
	return m_dwOutputPacketCount;
}

void CALLBACK CTsDescrambler::OnPatUpdated(const WORD wPID, CTsPidMapTarget *pMapTarget, CTsPidMapManager *pMapManager, const PVOID pParam)
{
	// PATXVꂽ
	CPatTable *pPatTable = static_cast<CPatTable *>(pMapTarget);

	// PMTe[uPID}bvǉ
	for(WORD wIndex = 0U ; wIndex < pPatTable->GetProgramNum() ; wIndex++){
		pMapManager->MapTarget(pPatTable->GetPmtPID(wIndex), new CPmtTable, CTsDescrambler::OnPmtUpdated, pParam);
		}
}

void CALLBACK CTsDescrambler::OnPmtUpdated(const WORD wPID, CTsPidMapTarget *pMapTarget, CTsPidMapManager *pMapManager, const PVOID pParam)
{
	// PMTXVꂽ
	CTsDescrambler *pThis = static_cast<CTsDescrambler *>(pParam);
	CPmtTable *pPmtTable = static_cast<CPmtTable *>(pMapTarget);

	// ECMPID}bvǉ
	const WORD wEcmPID = pPmtTable->GetCaMethodDesc()->GetCaPID();
	if(wEcmPID >= 0x1FFFU)return;

	// ECM^[QbgmF
	CEcmProcessor *pEcmProcessor = dynamic_cast<CEcmProcessor *>(pMapManager->GetMapTarget(wEcmPID));

	if(!pEcmProcessor){
		// ECMNXVK}bv
		pEcmProcessor = new CEcmProcessor(&pThis->m_BcasCard);
		pMapManager->MapTarget(wEcmPID, pEcmProcessor);
		}
	
	// ESPID}bvǉ
	for(WORD wIndex = 0U ; wIndex < pPmtTable->GetEsInfoNum() ; wIndex++){
		pMapManager->MapTarget(pPmtTable->GetEsPID(wIndex), new CEsProcessor(pEcmProcessor), NULL, pParam);
		}
}


//////////////////////////////////////////////////////////////////////
// CTsDescrambler::CEcmProcessor \z/
//////////////////////////////////////////////////////////////////////

CTsDescrambler::CEcmProcessor::CEcmProcessor(CBcasCard *pBcasCard)
	: CDynamicReferenceable()
	, CPsiSingleTable(true)
	, m_pBcasCard(pBcasCard)
	, m_dwRefCount(0UL)
{
	// MULTI2fR[_ɃVXeL[ƏCBCZbg
	m_Multi2Decoder.Initialize(m_pBcasCard->GetSystemKey(), m_pBcasCard->GetInitialCbc());
}

void CTsDescrambler::CEcmProcessor::OnPidMapped(const WORD wPID, const PVOID pParam)
{
	// QƃJEgǉ
	AddRef();
}

void CTsDescrambler::CEcmProcessor::OnPidUnmapped(const WORD wPID)
{
	// QƃJEgJ
	ReleaseRef();
}

const bool CTsDescrambler::CEcmProcessor::DescramblePacket(CTsPacket *pTsPacket)
{
	// XNu
	if(m_Multi2Decoder.Decode(pTsPacket->GetPayloadData(), (DWORD)pTsPacket->GetPayloadSize(), pTsPacket->m_Header.byTransportScramblingCtrl)){
		// gX|[gXNuĐݒ
		pTsPacket->SetAt(3UL, pTsPacket->GetAt(3UL) & 0x3FU);
		pTsPacket->m_Header.byTransportScramblingCtrl = 0U;
		return true;
		}
	
	return false;
}

const bool CTsDescrambler::CEcmProcessor::OnTableUpdate(const CPsiSection *pCurSection, const CPsiSection *pOldSection)
{
	// ECMB-CASJ[hɓnăL[擾
	const BYTE *KsData = m_pBcasCard->GetKsFromEcm(pCurSection->GetPayloadData(), pCurSection->GetPayloadSize());

	// XNuL[XV
	m_Multi2Decoder.SetScrambleKey(KsData);

	// L[擾s̏ꍇB-CASJ[hăI[v
	if(!KsData)m_pBcasCard->OpenCard();
	
	return true;
}


//////////////////////////////////////////////////////////////////////
// CTsDescrambler::CEsProcessor \z/
//////////////////////////////////////////////////////////////////////

CTsDescrambler::CEsProcessor::CEsProcessor(CTsDescrambler::CEcmProcessor *pEcmProcessor)
	: CTsPidMapTarget()
	, m_pEcmProcessor(pEcmProcessor)
{
	// QƃJEgǉ
	m_pEcmProcessor->AddRef();
}

CTsDescrambler::CEsProcessor::~CEsProcessor()
{
	// QƃJEg폜
	m_pEcmProcessor->ReleaseRef();
}

const bool CTsDescrambler::CEsProcessor::StorePacket(const CTsPacket *pPacket)
{
	// XNu
	m_pEcmProcessor->DescramblePacket(const_cast<CTsPacket *>(pPacket));

	return false;
}

void CTsDescrambler::CEsProcessor::OnPidUnmapped(const WORD wPID)
{
	// CX^XJ
	delete this;
}
