#include "stdafx.h"
#include "DtvEngine.h"


CDtvEngine::CDtvEngine(void)
{

}

CDtvEngine::~CDtvEngine(void)
{
	CloseEngine();
}

const bool CDtvEngine::OpenEngine(HWND hHostHwnd)
{
	// SɎb
	CloseEngine();

	// fR[_Ot\z
	m_BonSrcDecoder.SetOutputDecoder(&m_TsPacketParser, 0);		// Output #0 : CMediaData
	m_TsPacketParser.SetOutputDecoder(&m_TsDescrambler, 0);		// Output #0 : CTsPacket
	m_TsDescrambler.SetOutputDecoder(&m_TsDemuxer, 0);			// Output #0 : CTsPacket
	m_TsDemuxer.SetOutputDecoder(&m_MediaViewer, 0);			// Output #0 : CTsPacket

	// UZbg
	ResetEngine();

	try{
		// `[iJ
		if(!m_BonSrcDecoder.OpenTuner())throw 1UL;
	
		// B-CASJ[hJ
		if(!m_TsDescrambler.OpenBcasCard())throw 2UL;

		// r[AJ
		if(!m_MediaViewer.OpenViewer(hHostHwnd))throw 3UL;
		}
	catch(DWORD dwErrorNo){
		// G[
		switch(dwErrorNo){
			case 1UL :	::AfxMessageBox(TEXT("`[ȉɎs܂B"));		break;
			case 2UL :	::AfxMessageBox(TEXT("B-CASJ[h̏Ɏs܂B"));	break;
			case 3UL :	::AfxMessageBox(TEXT("MPEG2fR[_̏Ɏs܂B"));	break;
			}		
		
		CloseEngine();
		
		return false;
		}
	
	return true;
}

const bool CDtvEngine::CloseEngine(void)
{
	// fR[_N[Y
	m_BonSrcDecoder.CloseTuner();
	m_TsDescrambler.CloseBcasCard();
	m_MediaViewer.CloseViewer();

	return true;
}

const bool CDtvEngine::ResetEngine(void)
{
	// fR[_OtZbg
	m_BonSrcDecoder.Reset();

	return true;
}

const bool CDtvEngine::SetChannel(const BYTE byTuningSpace, const WORD wChannel)
{
	// `lύX
	return  m_BonSrcDecoder.SetChannel((BYTE)wChannel);
}

const bool CDtvEngine::EnablePreview(const bool bEnable)
{
	if(bEnable){
		// vr[L
		if(!m_BonSrcDecoder.Play())return false;
		if(!m_MediaViewer.Play())return false;
		}
	else{
		// vr[
		if(!m_MediaViewer.Stop())return false;
		if(!m_BonSrcDecoder.Stop())return false;
		}

	return true;
}

const DWORD CDtvEngine::GetLastError(void) const
{
	return 0UL;
}
